Imports System.Web.Mvc
Imports TreeDomainClasses
Imports TreesMVC.Models

Namespace TreesMVC.Controllers
  Public Class LeafController
	  Inherits Controller
	Private ReadOnly leafRepository As ILeafRepository

	' If you are using Dependency Injection, you can delete the following constructor
	Public Sub New()
		Me.New(New LeafRepository)
	End Sub

	Public Sub New(ByVal leafRepository As ILeafRepository)
	  Me.leafRepository = leafRepository
	End Sub

	Public Function Index(ByVal treeId As Integer) As ViewResult

	  ViewBag.TreeId = treeId
	  Dim treeRepository = New TreeRepository
	  Return View(treeRepository.LeavesForTree(treeId))
	End Function

	Public Function Details(ByVal id As Integer, ByVal treeId As Integer) As ViewResult
	  ViewBag.TreeId = treeId
	  Return View(leafRepository.Find(id))
	End Function

        Public Function Create(ByVal treeId As Integer) As ActionResult
            ViewBag.TreeId = treeId
            Return View()
        End Function

	<HttpPost>
	Public Function Create(ByVal leaf As Leaf) As ActionResult
	  If ModelState.IsValid Then
                Dim _treeId = Convert.ToInt32(Request.Form("TreeId"))
                leafRepository.InsertOrUpdate(leaf, _treeId)
                leafRepository.Save()
		Return RedirectToAction("Index", New With {Key .treeId = _treeId})
	  Else
		Return View()
	  End If
	End Function

	Public Function Edit(ByVal id As Integer, ByVal treeId As Integer) As ActionResult
	  ViewBag.TreeId = treeId
	  Return View(leafRepository.Find(id))
	End Function

	'
	' POST: /Leaf/Edit/5

	<HttpPost>
	Public Function Edit(ByVal leaf As Leaf) As ActionResult
	  If ModelState.IsValid Then
		leafRepository.InsertOrUpdate(leaf, Nothing)
		leafRepository.Save()
                Return RedirectToAction("Index", New With {Key .treeId = Request.Form("TreeId")})
	  Else
		Return View()
	  End If
	End Function

	'
	' GET: /Leaf/Delete/5

	Public Function Delete(ByVal id As Integer, ByVal treeId As Integer) As ActionResult
	  ViewBag.TreeId = treeId
	  Return View(leafRepository.Find(id))
	End Function

	'
	' POST: /Leaf/Delete/5

	<HttpPost, ActionName("Delete")>
	Public Function DeleteConfirmed(ByVal id As Integer) As ActionResult
            Dim _treeId As Integer = Convert.ToInt32(Request.Form("TreeId"))
            leafRepository.Delete(id)
            leafRepository.Save()

	  Return RedirectToAction("Index", New With {Key .treeId = _treeId})
	End Function
  End Class
End Namespace

