Imports System.Web.Mvc
Imports TreeDomainClasses
Imports TreesMVC.Models
Imports System.Data.Entity.Validation

Namespace TreesMVC.Controllers
  Public Class TreeController
	  Inherits Controller
	Private ReadOnly _treeRepository As ITreeRepository

	' If you are using Dependency Injection, you can delete the following constructor
	Public Sub New()
		Me.New(New TreeRepository)
	End Sub

	Public Sub New(ByVal treeRepository As ITreeRepository)
	  Me._treeRepository = treeRepository
	End Sub

	'
	' GET: /Tree/

	Public Function Index() As ViewResult
	  Return View(_treeRepository.AllIncluding(Function(tree) tree.Leaves))
	End Function

	'
	' GET: /Tree/Details/5

	Public Function Details(ByVal id As Integer) As ViewResult
	  Return View(_treeRepository.Find(id))
	End Function

	'
	' GET: /Tree/Create

	Public Function Create() As ActionResult
	  Return View()
	End Function

	<HttpPost>
	Public Function Create(ByVal tree As Tree) As ActionResult
	  Try
		_treeRepository.InsertOrUpdate(tree)
		_treeRepository.Save()
		Return RedirectToAction("Index")
	  Catch ex As DbEntityValidationException
		Dim [error] = ex.EntityValidationErrors.First().ValidationErrors.First()
		ModelState.AddModelError(String.Empty, [error].ErrorMessage)
	  End Try
	  Return View()
	End Function


	Public Function Edit(ByVal id As Integer) As ActionResult
	  Return View(_treeRepository.Find(id))
	End Function


	<HttpPost>
	Public Function Edit(ByVal tree As Tree) As ActionResult
	  Try
		_treeRepository.InsertOrUpdate(tree)
		_treeRepository.Save()
		Return RedirectToAction("Index")
	  Catch ex As DbEntityValidationException
		Dim [error] = ex.EntityValidationErrors.First().ValidationErrors.First()
		Me.ModelState.AddModelError(String.Empty, [error].ErrorMessage)
	  End Try
	  Return View()
	End Function



	Public Function Delete(ByVal id As Integer) As ActionResult
	  Return View(_treeRepository.Find(id))
	End Function

	'
	' POST: /Tree/Delete/5

	<HttpPost, ActionName("Delete")>
	Public Function DeleteConfirmed(ByVal id As Integer) As ActionResult
	  _treeRepository.Delete(id)
	  _treeRepository.Save()

	  Return RedirectToAction("Index")
	End Function
  End Class
End Namespace

